org.eclipse.rdf4j.query.parser.sparql

## Class TupleExprBuilder

- java.lang.Object
- - org.eclipse.rdf4j.query.parser.sparql.AbstractASTVisitor
  - - org.eclipse.rdf4j.query.parser.sparql.TupleExprBuilder

- All Implemented Interfaces:
    SyntaxTreeBuilderVisitor
  Direct Known Subclasses:
    UpdateExprBuilder

      public class TupleExprBuilder
      extends AbstractASTVisitor

  Author:
    Arjohn Kampman

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `TupleExprBuilder.SameTermCollector`
    `protected class` | `TupleExprBuilder.VarCollector`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TupleExprBuilder(ValueFactory valueFactory)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Value` | `getValueForExpr(ValueExpr valueExpr)` Retrieve the associated Value (if any) for the given valueExpr.
    `protected Var` | `mapValueExprToVar(ValueExpr valueExpr)` Maps the given valueExpr to a Var.
    `FunctionCall` | `visit(ASTAbs node, Object data)`
    `Object` | `visit(ASTAnd node, Object data)`
    `TupleExpr` | `visit(ASTAskQuery node, Object data)`
    `Object` | `visit(ASTAvg node, Object data)`
    `BindingSetAssignment` | `visit(ASTBindingsClause node, Object data)`
    `BindingSet` | `visit(ASTBindingSet node, Object data)`
    `ValueExpr` | `visit(ASTBindingValue node, Object data)`
    `Object` | `visit(ASTBind node, Object data)`
    `Object` | `visit(ASTBlankNode node, Object data)`
    `Var` | `visit(ASTBlankNodePropertyList node, Object data)`
    `Object` | `visit(ASTBNodeFunc node, Object data)`
    `ValueExpr` | `visit(ASTBound node, Object data)`
    `FunctionCall` | `visit(ASTCeil node, Object data)`
    `Coalesce` | `visit(ASTCoalesce node, Object data)`
    `Var` | `visit(ASTCollection node, Object data)`
    `Compare` | `visit(ASTCompare node, Object data)`
    `FunctionCall` | `visit(ASTConcat node, Object data)`
    `Object` | `visit(ASTConstraint node, Object data)`
    `TupleExpr` | `visit(ASTConstruct node, Object data)`
    `TupleExpr` | `visit(ASTConstructQuery node, Object data)`
    `FunctionCall` | `visit(ASTContains node, Object data)`
    `Object` | `visit(ASTCount node, Object data)`
    `Datatype` | `visit(ASTDatatype node, Object data)`
    `FunctionCall` | `visit(ASTDay node, Object data)`
    `TupleExpr` | `visit(ASTDescribe node, Object data)`
    `TupleExpr` | `visit(ASTDescribeQuery node, Object data)`
    `FunctionCall` | `visit(ASTEncodeForURI node, Object data)`
    `Exists` | `visit(ASTExistsFunc node, Object data)`
    `ValueConstant` | `visit(ASTFalse node, Object data)`
    `FunctionCall` | `visit(ASTFloor node, Object data)`
    `Object` | `visit(ASTFunctionCall node, Object data)`
    `Object` | `visit(ASTGraphGraphPattern node, Object data)`
    `Object` | `visit(ASTGraphPatternGroup node, Object data)`
    `Group` | `visit(ASTGroupClause node, Object data)`
    `Object` | `visit(ASTGroupConcat node, Object data)`
    `String` | `visit(ASTGroupCondition node, Object data)`
    `FunctionCall` | `visit(ASTHours node, Object data)`
    `If` | `visit(ASTIf node, Object data)`
    `ValueExpr` | `visit(ASTInfix node, Object data)`
    `BindingSetAssignment` | `visit(ASTInlineData node, Object data)`
    `ValueExpr` | `visit(ASTIn node, Object data)`
    `IRIFunction` | `visit(ASTIRIFunc node, Object data)`
    `ValueConstant` | `visit(ASTIRI node, Object data)`
    `IsBNode` | `visit(ASTIsBlank node, Object data)`
    `IsURI` | `visit(ASTIsIRI node, Object data)`
    `IsLiteral` | `visit(ASTIsLiteral node, Object data)`
    `IsNumeric` | `visit(ASTIsNumeric node, Object data)`
    `Object` | `visit(ASTLangMatches node, Object data)`
    `Lang` | `visit(ASTLang node, Object data)`
    `Long` | `visit(ASTLimit node, Object data)`
    `FunctionCall` | `visit(ASTLowerCase node, Object data)`
    `MathExpr` | `visit(ASTMath node, Object data)`
    `Object` | `visit(ASTMax node, Object data)`
    `FunctionCall` | `visit(ASTMD5 node, Object data)`
    `Object` | `visit(ASTMin node, Object data)`
    `Object` | `visit(ASTMinusGraphPattern node, Object data)`
    `FunctionCall` | `visit(ASTMinutes node, Object data)`
    `FunctionCall` | `visit(ASTMonth node, Object data)`
    `Not` | `visit(ASTNotExistsFunc node, Object data)`
    `ValueExpr` | `visit(ASTNotIn node, Object data)`
    `Not` | `visit(ASTNot node, Object data)`
    `FunctionCall` | `visit(ASTNow node, Object data)`
    `ValueConstant` | `visit(ASTNumericLiteral node, Object data)`
    `List<ValueExpr>` | `visit(ASTObjectList node, Object data)`
    `Long` | `visit(ASTOffset node, Object data)`
    `Object` | `visit(ASTOptionalGraphPattern node, Object data)`
    `List<OrderElem>` | `visit(ASTOrderClause node, Object data)`
    `OrderElem` | `visit(ASTOrderCondition node, Object data)`
    `Or` | `visit(ASTOr node, Object data)`
    `Object` | `visit(ASTPathAlternative pathAltNode, Object data)`
    `PropertySetElem` | `visit(ASTPathOneInPropertySet node, Object data)`
    `Object` | `visit(ASTPathSequence pathSeqNode, Object data)`
    `Object` | `visit(ASTPropertyList propListNode, Object data)`
    `Object` | `visit(ASTPropertyListPath propListNode, Object data)`
    `Object` | `visit(ASTQName node, Object data)`
    `TupleExpr` | `visit(ASTQueryContainer node, Object data)`
    `FunctionCall` | `visit(ASTRand node, Object data)`
    `ValueConstant` | `visit(ASTRDFLiteral node, Object data)`
    `Object` | `visit(ASTRegexExpression node, Object data)`
    `FunctionCall` | `visit(ASTReplace node, Object data)`
    `FunctionCall` | `visit(ASTRound node, Object data)`
    `SameTerm` | `visit(ASTSameTerm node, Object data)`
    `Sample` | `visit(ASTSample node, Object data)`
    `FunctionCall` | `visit(ASTSeconds node, Object data)`
    `TupleExpr` | `visit(ASTSelect node, Object data)`
    `TupleExpr` | `visit(ASTSelectQuery node, Object data)`
    `Object` | `visit(ASTServiceGraphPattern node, Object data)`
    `FunctionCall` | `visit(ASTSHA1 node, Object data)`
    `FunctionCall` | `visit(ASTSHA224 node, Object data)`
    `FunctionCall` | `visit(ASTSHA256 node, Object data)`
    `FunctionCall` | `visit(ASTSHA384 node, Object data)`
    `FunctionCall` | `visit(ASTSHA512 node, Object data)`
    `FunctionCall` | `visit(ASTStrAfter node, Object data)`
    `FunctionCall` | `visit(ASTStrBefore node, Object data)`
    `FunctionCall` | `visit(ASTStrDt node, Object data)`
    `FunctionCall` | `visit(ASTStrEnds node, Object data)`
    `String` | `visit(ASTString node, Object data)`
    `FunctionCall` | `visit(ASTStrLang node, Object data)`
    `FunctionCall` | `visit(ASTStrLen node, Object data)`
    `Object` | `visit(ASTStr node, Object data)`
    `FunctionCall` | `visit(ASTStrStarts node, Object data)`
    `FunctionCall` | `visit(ASTSTRUUID node, Object data)`
    `FunctionCall` | `visit(ASTSubstr node, Object data)`
    `Object` | `visit(ASTSum node, Object data)`
    `FunctionCall` | `visit(ASTTimezone node, Object data)`
    `ValueConstant` | `visit(ASTTrue node, Object data)`
    `FunctionCall` | `visit(ASTTz node, Object data)`
    `Object` | `visit(ASTUnionGraphPattern node, Object data)`
    `FunctionCall` | `visit(ASTUpperCase node, Object data)`
    `FunctionCall` | `visit(ASTUUID node, Object data)`
    `Var` | `visit(ASTVar node, Object data)`
    `FunctionCall` | `visit(ASTYear node, Object data)`

    - ### Methods inherited from class org.eclipse.rdf4j.query.parser.sparql.AbstractASTVisitor

      `visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TupleExprBuilder

          public TupleExprBuilder(ValueFactory valueFactory)

  - ### Method Detail

    - #### mapValueExprToVar

          protected Var mapValueExprToVar(ValueExpr valueExpr)

      Maps the given valueExpr to a Var. If the supplied ValueExpr is a Var, the object itself will be returned. If it is a ValueConstant, this method will check if an existing variable mapping exists and return that mapped variable, otherwise it will create and store a new mapping.
      Parameters:
        `valueExpr` -
      Returns:
        a Var for the given valueExpr.
      Throws:
        `IllegalArgumentException` - if the supplied ValueExpr is null or of an unexpected type.

    - #### getValueForExpr

          protected Value getValueForExpr(ValueExpr valueExpr)

      Retrieve the associated Value (if any) for the given valueExpr.
      Parameters:
        `valueExpr` -
      Returns:
        the value of the given ValueExpr, or null if no value exists.
      Throws:
        `IllegalArgumentException` - if the supplied ValueExpr is null or of an unexpected type.

    - #### visit

          public TupleExpr visit(ASTQueryContainer node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public TupleExpr visit(ASTSelectQuery node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public TupleExpr visit(ASTSelect node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public TupleExpr visit(ASTConstructQuery node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public TupleExpr visit(ASTConstruct node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public TupleExpr visit(ASTDescribeQuery node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public TupleExpr visit(ASTDescribe node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public TupleExpr visit(ASTAskQuery node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Group visit(ASTGroupClause node,
                             Object data)
                      throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public String visit(ASTGroupCondition node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public List<OrderElem> visit(ASTOrderClause node,
                                       Object data)
                                throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public OrderElem visit(ASTOrderCondition node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Long visit(ASTLimit node,
                            Object data)
                     throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Long visit(ASTOffset node,
                            Object data)
                     throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTGraphPatternGroup node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTServiceGraphPattern node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTOptionalGraphPattern node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTGraphGraphPattern node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTUnionGraphPattern node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTMinusGraphPattern node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTPropertyList propListNode,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTPathAlternative pathAltNode,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public PropertySetElem visit(ASTPathOneInPropertySet node,
                                       Object data)
                                throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTPathSequence pathSeqNode,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTPropertyListPath propListNode,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public List<ValueExpr> visit(ASTObjectList node,
                                       Object data)
                                throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Var visit(ASTBlankNodePropertyList node,
                           Object data)
                    throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Var visit(ASTCollection node,
                           Object data)
                    throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTConstraint node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Or visit(ASTOr node,
                          Object data)
                   throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTAnd node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Not visit(ASTNot node,
                           Object data)
                    throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Coalesce visit(ASTCoalesce node,
                                Object data)
                         throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Compare visit(ASTCompare node,
                               Object data)
                        throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSubstr node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTConcat node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTAbs node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTCeil node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTContains node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTFloor node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTRound node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTRand node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public SameTerm visit(ASTSameTerm node,
                                Object data)
                         throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Sample visit(ASTSample node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public MathExpr visit(ASTMath node,
                                Object data)
                         throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTFunctionCall node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTEncodeForURI node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTStr node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTStrDt node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTStrStarts node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTStrEnds node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTStrLen node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTStrAfter node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTStrBefore node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTUpperCase node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTLowerCase node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTStrLang node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTNow node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTYear node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTMonth node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTDay node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTHours node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTMinutes node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSeconds node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTTimezone node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTTz node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTMD5 node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSHA1 node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSHA224 node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSHA256 node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSHA384 node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSHA512 node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTUUID node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTSTRUUID node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public IRIFunction visit(ASTIRIFunc node,
                                   Object data)
                            throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Lang visit(ASTLang node,
                            Object data)
                     throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Datatype visit(ASTDatatype node,
                                Object data)
                         throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTLangMatches node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public BindingSetAssignment visit(ASTInlineData node,
                                            Object data)
                                     throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public BindingSetAssignment visit(ASTBindingsClause node,
                                            Object data)
                                     throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public BindingSet visit(ASTBindingSet node,
                                  Object data)
                           throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueExpr visit(ASTBindingValue node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueExpr visit(ASTBound node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public IsURI visit(ASTIsIRI node,
                             Object data)
                      throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public IsBNode visit(ASTIsBlank node,
                               Object data)
                        throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public IsLiteral visit(ASTIsLiteral node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public IsNumeric visit(ASTIsNumeric node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTBNodeFunc node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTRegexExpression node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public FunctionCall visit(ASTReplace node,
                                    Object data)
                             throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Exists visit(ASTExistsFunc node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Not visit(ASTNotExistsFunc node,
                           Object data)
                    throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public If visit(ASTIf node,
                          Object data)
                   throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueExpr visit(ASTInfix node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueExpr visit(ASTIn node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueExpr visit(ASTNotIn node,
                                 Object data)
                          throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Var visit(ASTVar node,
                           Object data)
                    throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueConstant visit(ASTIRI node,
                                     Object data)
                              throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTQName node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTBind node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTBlankNode node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueConstant visit(ASTRDFLiteral node,
                                     Object data)
                              throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueConstant visit(ASTNumericLiteral node,
                                     Object data)
                              throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueConstant visit(ASTTrue node,
                                     Object data)
                              throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public ValueConstant visit(ASTFalse node,
                                     Object data)
                              throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public String visit(ASTString node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTCount node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTGroupConcat node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTMax node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTMin node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTSum node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

    - #### visit

          public Object visit(ASTAvg node,
                              Object data)
                       throws VisitorException

      Specified by:
        `visit` in interface `SyntaxTreeBuilderVisitor`
      Overrides:
        `visit` in class `AbstractASTVisitor`
      Throws:
        `VisitorException`

Copyright © 2015-2020 Eclipse Foundation. All Rights Reserved.